import java.net.UnknownHostException;
import java.util.HashMap;
import java.util.Map;

import com.google.code.morphia.Datastore;
import com.google.code.morphia.Morphia;
import com.google.code.morphia.query.Query;
import com.google.code.morphia.query.QueryImpl;
import com.mongodb.Mongo;
import com.mongodb.MongoException;

public class Test {
	
	static Mongo mongo;
	static Morphia m;
	static Datastore ds;
	
	static {
		mongo = null;
		try {
			mongo = new Mongo();
		} catch (UnknownHostException e) {
			e.printStackTrace();
		} catch (MongoException e) {
			e.printStackTrace();
		}
		m = new Morphia();
		ds = m.createDatastore(mongo, "test");
	}
	
	public static void main(String[] args) {
		populate();
		query();
		
	}
	
	public static void query() {
		Query<TestEntity> q = ds.createQuery(TestEntity.class);
		
		q.and(q.or(q.criteria("map.field1").exists()),
				q.or(q.criteria("map.field2").exists()));
		
		Iterable<TestEntity> i = q.fetch();
		for (TestEntity e : i) {
			System.out.println("Result= " + e.map);
		}
		
		QueryImpl<TestEntity> qi = (QueryImpl<TestEntity>) q;
		System.out
				.println("Query= " + qi.prepareCursor().getQuery().toString());
	}
	
	public static void populate() {
		TestEntity e = new TestEntity();
		Map<String, Integer> map = new HashMap<String, Integer>();
		map.put("field1", 1);
		map.put("field2", 2);
		e.map = map;
		
		ds.save(e);
	}
}
